diff -x .git -x libkdcraw/libkdcraw/test -uNr libkdcraw-wrk/libkdcraw/libraw/internal/libraw_internal_funcs.h libkdcraw/libkdcraw/libraw/internal/libraw_internal_funcs.h
--- libkdcraw-wrk/libkdcraw/libraw/internal/libraw_internal_funcs.h	2022-11-07 08:15:53.614821808 +0300
+++ libkdcraw/libkdcraw/libraw/internal/libraw_internal_funcs.h	2022-11-07 07:46:31.726795008 +0300
@@ -1,24 +1,17 @@
-/*
+/* -*- C++ -*-
  * File: libraw_internal_funcs.h
- * Copyright 2008 Alex Tutubalin <lexa@lexa.ru>
+ * Copyright 2008-2020 LibRaw LLC (info@libraw.org)
  * Created: Sat Mar  14, 2008
- *
- * LibRaw internal data structures (not visible outside)
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2, or (at your option)
- * any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
- * 02110-1301, USA.
+
+LibRaw is free software; you can redistribute it and/or modify
+it under the terms of the one of two licenses as you choose:
+
+1. GNU LESSER GENERAL PUBLIC LICENSE version 2.1
+   (See file LICENSE.LGPL provided in LibRaw distribution archive for details).
+
+2. COMMON DEVELOPMENT AND DISTRIBUTION LICENSE (CDDL) Version 1.0
+   (See file LICENSE.CDDL provided in LibRaw distribution archive for details).
+
  */
 
 #ifndef _LIBRAW_INTERNAL_FUNCS_H
@@ -27,76 +20,193 @@
 #ifndef LIBRAW_LIBRARY_BUILD
 #error "This file should be used only for libraw library build"
 #else
-// inline functions
-    ushort      sget2 (uchar *s);
+
+/* inline functions */
+    static int stread(char *buf, size_t len, LibRaw_abstract_datastream *fp);
+    static int getwords(char *line, char *words[], int maxwords, int maxlen);
+    static void remove_trailing_spaces(char *string, size_t len);
+    static void remove_caseSubstr(char *string, char *remove);
+    static void removeExcessiveSpaces(char *string);
+    static void trimSpaces(char *s);
+/* static tables/variables */
+    static libraw_static_table_t tagtype_dataunit_bytes;
+    static libraw_static_table_t Canon_wbi2std;
+    static libraw_static_table_t Canon_KeyIsZero_Len2048_linenums_2_StdWBi;
+    static libraw_static_table_t Canon_KeyIs0x0410_Len3072_linenums_2_StdWBi;
+    static libraw_static_table_t Canon_KeyIs0x0410_Len2048_linenums_2_StdWBi;
+    static libraw_static_table_t Canon_D30_linenums_2_StdWBi;
+    static libraw_static_table_t Canon_G9_linenums_2_StdWBi;
+
+    static libraw_static_table_t Fuji_wb_list1;
+    static libraw_static_table_t FujiCCT_K;
+    static libraw_static_table_t Fuji_wb_list2;
+
+    static libraw_static_table_t Pentax_wb_list1;
+    static libraw_static_table_t Pentax_wb_list2;
+
+    static libraw_static_table_t Oly_wb_list1;
+    static libraw_static_table_t Oly_wb_list2;
+
+    static libraw_static_table_t Sony_SRF_wb_list;
+    static libraw_static_table_t Sony_SR2_wb_list;
+    static libraw_static_table_t Sony_SR2_wb_list1;
+/*  */
+    int     find_ifd_by_offset(int );
+    ushort	sget2 (uchar *s);
+    ushort	sget2Rev(uchar *s);
+    int 	parseCR3(unsigned long long oAtomList, unsigned long long szAtomList, short &nesting, char *AtomNameStack, short& nTrack, short &TrackType);
+    void	selectCRXTrack(short maxTrack);
+    void	setCanonBodyFeatures (unsigned long long id);
+    void	processCanonCameraInfo (unsigned long long id, uchar *CameraInfo, unsigned maxlen, unsigned type, unsigned dng_writer);
+    static float _CanonConvertAperture(ushort in);
+    void	Canon_CameraSettings(unsigned len);
+    void	Canon_WBpresets (int skip1, int skip2);
+    void	Canon_WBCTpresets (short WBCTversion);
+    void	parseCanonMakernotes (unsigned tag, unsigned type, unsigned len, unsigned dng_writer);
+    void	processNikonLensData (uchar *LensData, unsigned len);
+    void	Nikon_NRW_WBtag (int wb, int skip);
+    void	parseNikonMakernote (int base, int uptag, unsigned dng_writer);
+    void	parseEpsonMakernote (int base, int uptag, unsigned dng_writer);
+    void	parseSigmaMakernote (int base, int uptag, unsigned dng_writer);
+    void	setOlympusBodyFeatures (unsigned long long id);
+    void	getOlympus_CameraType2 ();
+    void	getOlympus_SensorTemperature (unsigned len);
+    void	parseOlympus_Equipment (unsigned tag, unsigned type, unsigned len, unsigned dng_writer);
+    void	parseOlympus_CameraSettings (int base, unsigned tag, unsigned type, unsigned len, unsigned dng_writer);
+    void	parseOlympus_ImageProcessing (unsigned tag, unsigned type, unsigned len, unsigned dng_writer);
+    void	parseOlympus_RawInfo (unsigned tag, unsigned type, unsigned len, unsigned dng_writer);
+    void	setPhaseOneFeatures (unsigned long long id);
+    void	setPentaxBodyFeatures (unsigned long long id);
+    void	PentaxISO (ushort c);
+    void	PentaxLensInfo (unsigned long long id, unsigned len);
+    void	parsePentaxMakernotes(int base, unsigned tag, unsigned type, unsigned len, unsigned dng_writer);
+    void	parseRicohMakernotes(int base, unsigned tag, unsigned type, unsigned len, unsigned dng_writer);
+    void	parseSamsungMakernotes(int base, unsigned tag, unsigned type, unsigned len, unsigned dng_writer);
+    void	setSonyBodyFeatures (unsigned long long id);
+    void	fixupArri();
+    void	parseSonyLensType2 (uchar a, uchar b);
+    void	parseSonyLensFeatures (uchar a, uchar b);
+    void	process_Sony_0x0116 (uchar * buf, ushort, unsigned long long id);
+    void	process_Sony_0x2010 (uchar * buf, ushort);
+    void	process_Sony_0x9050 (uchar * buf, ushort, unsigned long long id);
+    void	process_Sony_0x9400 (uchar * buf, ushort, unsigned long long id);
+    void	process_Sony_0x9402 (uchar * buf, ushort);
+    void	process_Sony_0x9403 (uchar * buf, ushort);
+    void	process_Sony_0x9406 (uchar * buf, ushort);
+    void	process_Sony_0x940c (uchar * buf, ushort);
+    void	process_Sony_0x940e (uchar * buf, ushort, unsigned long long id);
+    void	parseSonyMakernotes (int base, unsigned tag, unsigned type, unsigned len, unsigned dng_writer,
+                               uchar *&table_buf_0x0116, ushort &table_buf_0x0116_len,
+                               uchar *&table_buf_0x2010, ushort &table_buf_0x2010_len,
+                               uchar *&table_buf_0x9050, ushort &table_buf_0x9050_len,
+                               uchar *&table_buf_0x9400, ushort &table_buf_0x9400_len,
+                               uchar *&table_buf_0x9402, ushort &table_buf_0x9402_len,
+                               uchar *&table_buf_0x9403, ushort &table_buf_0x9403_len,
+                               uchar *&table_buf_0x9406, ushort &table_buf_0x9406_len,
+                               uchar *&table_buf_0x940c, ushort &table_buf_0x940c_len,
+                               uchar *&table_buf_0x940e, ushort &table_buf_0x940e_len);
+    void	parseSonySR2 (uchar *cbuf_SR2, unsigned SR2SubIFDOffset, unsigned SR2SubIFDLength, unsigned dng_writer);
+    void	parseSonySRF (unsigned len);
+    void	parseFujiMakernotes (unsigned tag, unsigned type, unsigned len, unsigned dng_writer);
+    const char* HassyRawFormat_idx2HR(unsigned idx);
+    void	process_Hassy_Lens (int LensMount);
+    void parseHassyModel ();
+
+    void	setLeicaBodyFeatures(int LeicaMakernoteSignature);
+    void	parseLeicaLensID();
+    int 	parseLeicaLensName(unsigned len);
+    int 	parseLeicaInternalBodySerial(unsigned len);
+    void	parseLeicaMakernote(int base, int uptag, unsigned MakernoteTagType);
+    void	parseAdobePanoMakernote ();
+    void	parseAdobeRAFMakernote ();
+    void	GetNormalizedModel ();
+    void	SetStandardIlluminants (unsigned, const char* );
+
     ushort      get2();
     unsigned    sget4 (uchar *s);
     unsigned    getint (int type);
     float       int_to_float (int i);
     double      getreal (int type);
-    void        read_shorts (ushort *pixel, int count);
+    double      sgetreal(int type, uchar *s);
+    void        read_shorts (ushort *pixel, unsigned count);
 
-// Canon P&S cameras
+/* Canon P&S cameras */
     void        canon_600_fixed_wb (int temp);
     int         canon_600_color (int ratio[2], int mar);
     void        canon_600_auto_wb();
     void        canon_600_coeff();
     void        canon_600_load_raw();
+    void        canon_600_correct();
     int         canon_s2is();
-    void        canon_a5_load_raw();
-    void        parse_ciff (int offset, int length);
+    void        parse_ciff (int offset, int length, int);
     void        ciff_block_1030();
 
+
 // LJPEG decoder
-    unsigned    getbits (int nbits);
-    void        init_decoder();
-    uchar *     make_decoder (const uchar *source, int level);
+    unsigned    getbithuff (int nbits, ushort *huff);
+    ushort*     make_decoder_ref (const uchar **source);
+    ushort*     make_decoder (const uchar *source);
     int         ljpeg_start (struct jhead *jh, int info_only);
-    int         ljpeg_diff (struct decode *dindex);
+    void        ljpeg_end(struct jhead *jh);
+    int         ljpeg_diff (ushort *huff);
     ushort *    ljpeg_row (int jrow, struct jhead *jh);
+    ushort *    ljpeg_row_unrolled (int jrow, struct jhead *jh);
+    void	    ljpeg_idct (struct jhead *jh);
+    unsigned    ph1_bithuff (int nbits, ushort *huff);
 
 // Canon DSLRs
-    void        crw_init_tables (unsigned table);
+    void        crw_init_tables (unsigned table, ushort *huff[2]);
     int         canon_has_lowbits();
-    void        canon_compressed_load_raw();
+    void        canon_load_raw();
     void        lossless_jpeg_load_raw();
     void        canon_sraw_load_raw();
-    void        canon_black(double *);
 // Adobe DNG
-    void        adobe_copy_pixel (int row, int col, ushort **rp);
-    void        adobe_dng_load_raw_lj();
-    void        adobe_dng_load_raw_nc();
+    void        adobe_copy_pixel (unsigned int row, unsigned int col, ushort **rp);
+    void        lossless_dng_load_raw();
+    void        deflate_dng_load_raw();
+    void        packed_dng_load_raw();
+    void        lossy_dng_load_raw();
+//void        adobe_dng_load_raw_nc();
 
 // Pentax
-    void        pentax_k10_load_raw();
+    void        pentax_load_raw();
+    void	pentax_4shot_load_raw();
+
     void        pentax_tree();
 
 // Nikon (and Minolta Z2)
-    void        nikon_compressed_load_raw();
     void        nikon_load_raw();
-    int         nikon_is_compressed();
+    void        nikon_read_curve();
+    void        nikon_load_striped_packed_raw();
+    void        nikon_load_padded_packed_raw();
+    void        nikon_load_sraw();
+    void        nikon_yuv_load_raw();
+    void        nikon_coolscan_load_raw();
     int         nikon_e995();
     int         nikon_e2100();
     void        nikon_3700();
     int         minolta_z2();
-    void        nikon_e900_load_raw();
-    void        nikon_e2100_load_raw();
+//    void        nikon_e2100_load_raw();
 
 // Fuji
-    void        fuji_load_raw();
+//void        fuji_load_raw();
     void        parse_fuji (int offset);
 
-
-
+// RedCine
+    void        parse_redcine();
+    void        redcine_load_raw();
 
 // Rollei
     void        rollei_load_raw();
     void        parse_rollei();
 
+// Contax
+    void        parse_kyocera ();
+
 // MF backs
-    int         bayer (unsigned row, unsigned col);
+//int         bayer (unsigned row, unsigned col);
+    int         p1raw(unsigned,unsigned);
     void        phase_one_flat_field (int is_float, int nc);
-    void        phase_one_correct();
     void        phase_one_load_raw();
     unsigned    ph1_bits (int nbits);
     void        phase_one_load_raw_c();
@@ -104,20 +214,29 @@
     void        leaf_hdr_load_raw();
     void        sinar_4shot_load_raw();
     void        imacon_full_load_raw();
-    void        packed_12_load_raw();
+    void        hasselblad_full_load_raw();
+    void        packed_load_raw();
+    float       find_green(int,int,int,int);
     void        unpacked_load_raw();
+    void        unpacked_load_raw_FujiDBP();
+    void        unpacked_load_raw_reversed();
+    void        unpacked_load_raw_fuji_f700s20();
     void        parse_sinar_ia();
     void        parse_phase_one (int base);
 
 // Misc P&S cameras
+    void        parse_broadcom();
+    void        broadcom_load_raw();
     void        nokia_load_raw();
-    unsigned    pana_bits (int nbits);
+    void        android_loose_load_raw();
+    void        android_tight_load_raw();
+    void        canon_rmf_load_raw();
+    unsigned    pana_data (int nb, unsigned *bytes);
     void        panasonic_load_raw();
-    void        olympus_e300_load_raw();
-    void        olympus_e410_load_raw();
-    void        olympus_cseries_load_raw();
+//    void        panasonic_16x10_load_raw();
+    void        olympus_load_raw();
+//    void        olympus_cseries_load_raw();
     void        minolta_rd175_load_raw();
-    void        casio_qv5700_load_raw();
     void        quicktake_100_load_raw();
     const int*  make_decoder_int (const int *source, int level);
     int         radc_token (int tree);
@@ -140,62 +259,130 @@
     int         kodak_65000_decode (short *out, int bsize);
     void        kodak_65000_load_raw();
     void        kodak_rgb_load_raw();
-    void        kodak_yrgb_load_raw();
-
+    void        kodak_ycbcr_load_raw();
+//    void        kodak_yrgb_load_raw();
+    void        kodak_c330_load_raw();
+    void        kodak_c603_load_raw();
+    void        kodak_rgb_load_thumb();
+    void        kodak_ycbcr_load_thumb();
+    void        float_dng_load_raw_placeholder();
+    void        vc5_dng_load_raw_placeholder();
 // It's a Sony (and K&M)
     void        sony_decrypt (unsigned *data, int len, int start, int key);
     void        sony_load_raw();
     void        sony_arw_load_raw();
     void        sony_arw2_load_raw();
+    void        sony_arq_load_raw();
+    void        samsung_load_raw();
+    void        samsung2_load_raw();
+    void        samsung3_load_raw();
     void        parse_minolta (int base);
 
-#ifndef NO_FOVEON
+#ifdef USE_X3FTOOLS
 // Foveon/Sigma
-    void        foveon_load_camf();
-    void        foveon_load_raw();
-    const char* foveon_camf_param (const char *block, const char *param);
-    void *      foveon_camf_matrix (unsigned dim[3], const char *name);
-    int         foveon_fixed (void *ptr, int size, const char *name);
-    float       foveon_avg (short *pix, int range[2], float cfilt);
-    short *     foveon_make_curve (double max, double mul, double filt);
-    void        foveon_make_curves(short **curvep, float dq[3], float div[3], float filt);
-    int         foveon_apply_curve (short *curve, int i);
-    void        foveon_interpolate();
-    char *      foveon_gets (int offset, char *str, int len);
-    void        parse_foveon();
+// We always have x3f code compiled in!
+    void        parse_x3f();
+    void        x3f_load_raw();
+    void        x3f_dpq_interpolate_rg();
+	void        x3f_dpq_interpolate_af(int xstep, int ystep, int scale); // 1x1 af pixels
+	void        x3f_dpq_interpolate_af_sd(int xstart,int ystart, int xend, int yend, int xstep, int ystep, int scale); // sd Quattro interpolation
+#else
+	void        parse_x3f() {}
+	void        x3f_load_raw(){}
+#endif
+#ifdef USE_6BY9RPI
+	void		rpi_load_raw8();
+	void		rpi_load_raw12();
+	void		rpi_load_raw14();
+	void		rpi_load_raw16();
+	void		parse_raspberrypi();
 #endif
-
 
 // CAM/RGB
     void        pseudoinverse (double (*in)[3], double (*out)[3], int size);
-    void        cam_xyz_coeff (double cam_xyz[4][3]);
-    void        adobe_coeff (const char *, const char *);
     void        simple_coeff (int index);
 
 
 // Tiff/Exif parsers
     void        tiff_get (unsigned base,unsigned *tag, unsigned *type, unsigned *len, unsigned *save);
+    short       tiff_sget(unsigned save, uchar *buf, unsigned buf_len, INT64 *tag_offset,
+                          unsigned *tag_id, unsigned *tag_type, INT64 *tag_dataoffset,
+                          unsigned *tag_datalen, int *tag_dataunit_len);
     void        parse_thumb_note (int base, unsigned toff, unsigned tlen);
     void        parse_makernote (int base, int uptag);
+    void        parse_makernote_0xc634(int base, int uptag, unsigned dng_writer);
     void        parse_exif (int base);
-    void        linear_table (unsigned len);
+	void        parse_exif_interop(int base);
+	void        linear_table(unsigned len);
+    void        Kodak_DCR_WBtags(int wb, unsigned type, int wbi);
+    void        Kodak_KDC_WBtags(int wb, int wbi);
+    short       KodakIllumMatrix (unsigned type, float *romm_camIllum);
     void        parse_kodak_ifd (int base);
     int         parse_tiff_ifd (int base);
-    void        parse_tiff (int base);
+    int         parse_tiff (int base);
+    void        apply_tiff(void);
     void        parse_gps (int base);
-    void        romm_coeff (float romm_cam[3][3]);
+    void        parse_gps_libraw(int base);
+    void        aRGB_coeff(double aRGB_cam[3][3]);
+    void        romm_coeff(float romm_cam[3][3]);
     void        parse_mos (int offset);
+    void        parse_qt (int end);
     void        get_timestamp (int reversed);
 
-// External JPEGs, what cameras uses it ?
-    void        parse_external_jpeg();
-
 // The identify
     short       guess_byte_order (int words);
-
+	void		identify_process_dng_fields();
+	void		identify_finetune_pentax();
+	void		identify_finetune_by_filesize(int);
+	void		identify_finetune_dcr(char head[64],int,int);
 // Tiff writer
-    void        tiff_set (ushort *ntag, ushort tag, ushort type, int count, int val);
+    void        tiff_set(struct tiff_hdr *th, ushort *ntag,ushort tag, ushort type, int count, int val);
     void        tiff_head (struct tiff_hdr *th, int full);
+
+// split AHD code
+    void ahd_interpolate_green_h_and_v(int top, int left, ushort (*out_rgb)[LIBRAW_AHD_TILE][LIBRAW_AHD_TILE][3]);
+    void ahd_interpolate_r_and_b_in_rgb_and_convert_to_cielab(int top, int left, ushort (*inout_rgb)[LIBRAW_AHD_TILE][3], short (*out_lab)[LIBRAW_AHD_TILE][3]);
+    void ahd_interpolate_r_and_b_and_convert_to_cielab(int top, int left, ushort (*inout_rgb)[LIBRAW_AHD_TILE][LIBRAW_AHD_TILE][3], short (*out_lab)[LIBRAW_AHD_TILE][LIBRAW_AHD_TILE][3]);
+    void ahd_interpolate_build_homogeneity_map(int top, int left, short (*lab)[LIBRAW_AHD_TILE][LIBRAW_AHD_TILE][3], char (*out_homogeneity_map)[LIBRAW_AHD_TILE][2]);
+    void ahd_interpolate_combine_homogeneous_pixels(int top, int left, ushort (*rgb)[LIBRAW_AHD_TILE][LIBRAW_AHD_TILE][3], char (*homogeneity_map)[LIBRAW_AHD_TILE][2]);
+
+	void init_fuji_compr(struct fuji_compressed_params* info);
+	void init_fuji_block(struct fuji_compressed_block* info, const struct fuji_compressed_params *params, INT64 raw_offset, unsigned dsize);
+	void copy_line_to_xtrans(struct fuji_compressed_block* info, int cur_line, int cur_block, int cur_block_width);
+	void copy_line_to_bayer(struct fuji_compressed_block* info, int cur_line, int cur_block, int cur_block_width);
+	void xtrans_decode_block(struct fuji_compressed_block* info, const struct fuji_compressed_params *params, int cur_line);
+	void fuji_bayer_decode_block(struct fuji_compressed_block* info, const struct fuji_compressed_params *params, int cur_line);
+	void fuji_compressed_load_raw();
+	void fuji_14bit_load_raw();
+	void parse_fuji_compressed_header();
+    void crxLoadRaw();
+    int  crxParseImageHeader(uchar *cmp1TagData, int nTrack);
+	void panasonicC6_load_raw();
+	void panasonicC7_load_raw();
+
+	void nikon_14bit_load_raw();
+
+// DCB
+    void  	dcb_pp();
+    void  	dcb_copy_to_buffer(float (*image2)[3]);
+    void  	dcb_restore_from_buffer(float (*image2)[3]);
+    void  	dcb_color();
+    void  	dcb_color_full();
+    void  	dcb_map();
+    void  	dcb_correction();
+    void  	dcb_correction2();
+    void  	dcb_refinement();
+    void  	rgb_to_lch(double (*image3)[3]);
+    void  	lch_to_rgb(double (*image3)[3]);
+    void  	fbdd_correction();
+    void  	fbdd_correction2(double (*image3)[3]);
+    void  	fbdd_green();
+    void  	dcb_ver(float (*image3)[3]);
+    void 	dcb_hor(float (*image2)[3]);
+    void 	dcb_color2(float (*image2)[3]);
+    void 	dcb_color3(float (*image3)[3]);
+    void 	dcb_decide(float (*image2)[3], float (*image3)[3]);
+    void 	dcb_nyquist();
 #endif
 
 #endif
diff -x .git -x libkdcraw/libkdcraw/test -uNr libkdcraw-wrk/libkdcraw/libraw/internal/var_defines.h libkdcraw/libkdcraw/libraw/internal/var_defines.h
--- libkdcraw-wrk/libkdcraw/libraw/internal/var_defines.h	2022-11-07 08:15:53.614821808 +0300
+++ libkdcraw/libkdcraw/libraw/internal/var_defines.h	2022-11-07 07:46:31.726795008 +0300
@@ -1,45 +1,51 @@
-/*
+/* -*- C++ -*-
  * File: var_defines.h
- * Copyright 2008-2009 Alex Tutubalin <lexa@lexa.ru>
+ * Copyright 2008-2020 LibRaw LLC (info@libraw.org)
  * Created: Sat Mar  8, 2008
  *
  * LibRaw redefinitions of dcraw internal variables
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2, or (at your option)
- * any later version.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
- * 02110-1301, USA.
+
+LibRaw is free software; you can redistribute it and/or modify
+it under the terms of the one of two licenses as you choose:
+
+1. GNU LESSER GENERAL PUBLIC LICENSE version 2.1
+   (See file LICENSE.LGPL provided in LibRaw distribution archive for details).
+
+2. COMMON DEVELOPMENT AND DISTRIBUTION LICENSE (CDDL) Version 1.0
+   (See file LICENSE.CDDL provided in LibRaw distribution archive for details).
+
  */
 
 #ifndef VAR_DEFINES_H
 #define VAR_DEFINES_H
 
-// imgdata.idata
-#define make            (imgdata.idata.make)
-#define model           (imgdata.idata.model)
-#define is_raw          (imgdata.idata.raw_count)
-#define dng_version     (imgdata.idata.dng_version)
-#define is_foveon       (imgdata.idata.is_foveon)
-#define colors          (imgdata.idata.colors)
-#define cdesc           (imgdata.idata.cdesc)
-#define filters         (imgdata.idata.filters)
 
+// imgdata.idata
+#define make             (imgdata.idata.make)
+#define model            (imgdata.idata.model)
+#define software         (imgdata.idata.software)
+#define is_raw           (imgdata.idata.raw_count)
+#define dng_version      (imgdata.idata.dng_version)
+#define is_foveon        (imgdata.idata.is_foveon)
+#define colors           (imgdata.idata.colors)
+#define cdesc            (imgdata.idata.cdesc)
+#define filters          (imgdata.idata.filters)
+#define xtrans           (imgdata.idata.xtrans)
+#define xtrans_abs       (imgdata.idata.xtrans_abs)
+#define xmpdata          (imgdata.idata.xmpdata)
+#define xmplen           (imgdata.idata.xmplen)
 //imgdata image
-#define image           (imgdata.image)
+#define image            (imgdata.image)
+#define raw_image        (imgdata.rawdata.raw_image)
+#define color_image      (imgdata.rawdata.color_image)
+#define normalized_make  (imgdata.idata.normalized_make)
+#define normalized_model (imgdata.idata.normalized_model)
+#define maker_index      (imgdata.idata.maker_index)
 
 // imgdata.sizes
 #define raw_height      (imgdata.sizes.raw_height)
 #define raw_width       (imgdata.sizes.raw_width)
+#define raw_pitch       (imgdata.sizes.raw_pitch)
 #define height          (imgdata.sizes.height)
 #define width           (imgdata.sizes.width)
 #define top_margin      (imgdata.sizes.top_margin)
@@ -50,6 +56,8 @@
 #define iwidth          (imgdata.sizes.iwidth)
 #define pixel_aspect    (imgdata.sizes.pixel_aspect)
 #define flip            (imgdata.sizes.flip)
+#define mask            (imgdata.sizes.mask)
+#define raw_stride		(libraw_internal_data.unpacker_data.raw_stride)
 
 //imgdata.color
 #define white           (imgdata.color.white)
@@ -62,8 +70,10 @@
 #endif
 #ifndef SRC_USES_BLACK
 #define black           (imgdata.color.black)
+#define cblack           (imgdata.color.cblack)
 #endif
 #define maximum         (imgdata.color.maximum)
+#define channel_maximum         (imgdata.color.channel_maximum)
 #define profile_length  (imgdata.color.profile_length)
 #define color_flags     (imgdata.color.color_flags)
 #define ph1             (imgdata.color.phase_one_data)
@@ -72,25 +82,27 @@
 #define model2          (imgdata.color.model2)
 
 //imgdata.thumbnail
-
 #define thumb_width     (imgdata.thumbnail.twidth)
 #define thumb_height    (imgdata.thumbnail.theight)
 #define thumb_length    (imgdata.thumbnail.tlength)
 
 
 //imgdata.others
-#define iso_speed       (imgdata.other.iso_speed)
-#define shutter         (imgdata.other.shutter)
-#define aperture        (imgdata.other.aperture)
-#define focal_len       (imgdata.other.focal_len)
-#define timestamp       (imgdata.other.timestamp)
-#define shot_order      (imgdata.other.shot_order)
-#define gpsdata         (imgdata.other.gpsdata)
-#define desc            (imgdata.other.desc)
-#define artist          (imgdata.other.artist)
+#define iso_speed        (imgdata.other.iso_speed)
+#define shutter          (imgdata.other.shutter)
+#define aperture         (imgdata.other.aperture)
+#define focal_len        (imgdata.other.focal_len)
+#define timestamp        (imgdata.other.timestamp)
+#define shot_order       (imgdata.other.shot_order)
+#define gpsdata          (imgdata.other.gpsdata)
+#define desc             (imgdata.other.desc)
+#define artist           (imgdata.other.artist)
+
+#define FujiCropMode     (imgdata.makernotes.fuji.CropMode)
 
 //imgdata.output
 #define greybox         (imgdata.params.greybox)
+#define cropbox         (imgdata.params.cropbox)
 #define aber            (imgdata.params.aber)
 #define gamm            (imgdata.params.gamm)
 #define user_mul        (imgdata.params.user_mul)
@@ -99,9 +111,7 @@
 #define threshold       (imgdata.params.threshold)
 #define half_size       (imgdata.params.half_size)
 #define four_color_rgb  (imgdata.params.four_color_rgb)
-#define document_mode   (imgdata.params.document_mode)
 #define highlight       (imgdata.params.highlight)
-//#define verbose         (imgdata.params.verbose)
 #define use_auto_wb     (imgdata.params.use_auto_wb)
 #define use_camera_wb   (imgdata.params.use_camera_wb)
 #define use_camera_matrix (imgdata.params.use_camera_matrix)
@@ -111,19 +121,23 @@
 #define output_tiff     (imgdata.params.output_tiff)
 #define med_passes      (imgdata.params.med_passes)
 #define no_auto_bright  (imgdata.params.no_auto_bright)
+#define auto_bright_thr  (imgdata.params.auto_bright_thr)
 #define use_fuji_rotate (imgdata.params.use_fuji_rotate)
 #define filtering_mode (imgdata.params.filtering_mode)
 
-//rgb_constants
-#define xyz_rgb         (rgb_constants.xyz_rgb)
-#define d65_white       (rgb_constants.d65_white)
+// DCB
+#define dcb_iterations   (imgdata.params.iterations)
+#define dcb_enhance_fl   (imgdata.params.dcb_enhance)
+#define fbdd_noiserd     (imgdata.params.fbdd_noiserd)
 
 //libraw_internal_data.internal_data
 #define meta_data       (libraw_internal_data.internal_data.meta_data)
 #define ifp             libraw_internal_data.internal_data.input
 #define ifname          ((char*)libraw_internal_data.internal_data.input->fname())
+#define ofp             libraw_internal_data.internal_data.output
 #define profile_offset  (libraw_internal_data.internal_data.profile_offset)
 #define thumb_offset    (libraw_internal_data.internal_data.toffset)
+#define pana_black		(libraw_internal_data.internal_data.pana_black)
 
 //libraw_internal_data.internal_output_params
 #define mix_green       (libraw_internal_data.internal_output_params.mix_green)
@@ -143,8 +157,10 @@
 //libraw_internal_data.identify_data
 #define exif_cfa        (libraw_internal_data.identify_data.olympus_exif_cfa)
 #define unique_id       (libraw_internal_data.identify_data.unique_id)
+#define OlyID           (libraw_internal_data.identify_data.OlyID)
 #define tiff_nifds      (libraw_internal_data.identify_data.tiff_nifds)
 #define tiff_flip       (libraw_internal_data.identify_data.tiff_flip)
+#define metadata_blocks (libraw_internal_data.identify_data.metadata_blocks)
 
 //libraw_internal_data.unpacker_data
 #define order           (libraw_internal_data.unpacker_data.order)
@@ -154,6 +170,7 @@
 #define kodak_cbpp      (libraw_internal_data.unpacker_data.kodak_cbpp)
 #define strip_offset    (libraw_internal_data.unpacker_data.strip_offset)
 #define data_offset     (libraw_internal_data.unpacker_data.data_offset)
+#define data_size     (libraw_internal_data.unpacker_data.data_size)
 #define meta_offset     (libraw_internal_data.unpacker_data.meta_offset)
 #define meta_length     (libraw_internal_data.unpacker_data.meta_length)
 #define thumb_misc      (libraw_internal_data.unpacker_data.thumb_misc)
@@ -161,10 +178,21 @@
 #define tiff_samples    (libraw_internal_data.unpacker_data.tiff_samples)
 #define tiff_bps        (libraw_internal_data.unpacker_data.tiff_bps)
 #define tiff_compress   (libraw_internal_data.unpacker_data.tiff_compress)
+#define tiff_sampleformat (libraw_internal_data.unpacker_data.tiff_sampleformat)
 #define zero_after_ff   (libraw_internal_data.unpacker_data.zero_after_ff)
 #define tile_width      (libraw_internal_data.unpacker_data.tile_width)
 #define tile_length     (libraw_internal_data.unpacker_data.tile_length)
 #define load_flags      (libraw_internal_data.unpacker_data.load_flags)
+#define pana_encoding   (libraw_internal_data.unpacker_data.pana_encoding)
+#define pana_bpp        (libraw_internal_data.unpacker_data.pana_bpp)
+#define CM_found        (libraw_internal_data.unpacker_data.CM_found)
+
+#define is_NikonTransfer (libraw_internal_data.unpacker_data.is_NikonTransfer)
+#define is_Sony          (libraw_internal_data.unpacker_data.is_Sony)
+#define is_4K_RAFdata    (libraw_internal_data.unpacker_data.is_4K_RAFdata)
+#define is_PentaxRicohMakernotes    (libraw_internal_data.unpacker_data.is_PentaxRicohMakernotes)
+#define is_pana_raw      (libraw_internal_data.unpacker_data.is_pana_raw)
+
 
 #ifdef LIBRAW_IO_REDEFINED
 #define fread(ptr,size,n,stream) stream->read(ptr,size,n)
@@ -172,8 +200,13 @@
 #define fseeko(stream,o,w)	 stream->seek(o,w)
 #define ftell(stream)		 stream->tell()
 #define ftello(stream)		 stream->tell()
+#define feof(stream)		 stream->eof()
+#ifdef getc
+#undef getc
+#endif
 #define getc(stream)		 stream->get_char()
 #define fgetc(stream)		 stream->get_char()
+#define fgetcb(stream)		 stream->get_char_buf()
 #define fgets(str,n,stream)	 stream->gets(str,n)
 #define fscanf(stream,fmt,ptr)	 stream->scanf_one(fmt,ptr)
 #endif
